#!/usr/bin/perl

sub processdir($) {
    my $path = $_[0];
    local *DIR;
    if(!opendir(DIR, $path)) {
	print "*** cannot open directory: $path\n";
	return;
    }
    while($_ = readdir DIR) {
	next if($_ eq '.' or $_ eq '..');
	my $path2 = $path.'/'.$_;
	if(-d $path2) {
	    processdir($path2);
	} else {
	    if(m/\.mp3\Z/i) {
		system "./mp3-uniencode", @options, $path2;
	    }
	}
    }
    closedir(DIR);
}

if(substr($ARGV[0], 0, 1) eq '-') {
    $mode = 0;
} else {
    $mode = 1;
}

@options = ();
@directories = ();
foreach(@ARGV) {
    if($mode == 0) {
	if($_ eq '--') {
	    $mode = 1;
	} else {
	    push @options, $_;
	}
    } else {
	push @directories, $_;
    }
}

if($#directories == -1) {
    print "mp3-recurse-uniencode: no target directories specified.\n";
    print " usage: mp3-recurse-uniencode [[options...] --] <directories...>\n";
    print "  all options for mp3-uniencode are available.\n";
    print "  after options, you need '--' before specifying dircetories.\n";
    exit(1);
}

foreach(@directories) {
    processdir($_);
}
